#! /usr/bin/env python
#
# Copyright INRA-URGI 2009-2010
# 
# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software. You can use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".
# 
# As a counterpart to the access to the source code and rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty and the software's author, the holder of the
# economic rights, and the successive licensors have only limited
# liability.
# 
# In this respect, the user's attention is drawn to the risks associated
# with loading, using, modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean that it is complicated to manipulate, and that also
# therefore means that it is reserved for developers and experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and, more generally, to use and operate it in the
# same conditions as regards security.
# 
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.
#

from SMART.Java.Python.structure.Transcript import Transcript

class NCIndex(object):

    def __init__(self, verbosity):
        self._verbosity = verbosity
        self._step      = 10000
        self._indices   = []

    def setStep(self, step):
        self._step = step

    def addTranscript(self, end, index):
        binStart = len(self._indices)
        binEnd   = int(end / self._step)
        for bin in range(binStart, binEnd+1):
            self._indices.append(index)

    def getIndex(self, transcript):
        bin = int(transcript.getStart() / self._step)
        if bin >= len(self._indices):
            return self._indices[-1]
        return self._indices[bin]

